%define immodule 1

%define ver 3.3.8b

%define qt_dirname qt-3.3
%define qtdir %{_libdir}/%{qt_dirname}
%define qt_docdir %{_docdir}/qt-devel-%{version}

# buildmt: Build libs with threading support
%define buildmt 1

# cups support
%define cups 1

%define plugins -qt-style-cde -qt-style-motifplus -qt-style-platinum -qt-style-sgi -qt-style-windows -qt-style-compact -qt-imgfmt-png -qt-imgfmt-jpeg -qt-imgfmt-mng

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	Qt is a widget library, forming the base of KDE and other X applications.
Name:      	qt3
Version:   	%{ver}
Release:   	4
License: 	GNU/GPL
URL:		http://www.trolltech.com
Group:     	System/Libraries
Source0: 	ftp://ftp.troll.no/qt/source/qt-x11-free-%{version}.tar.gz
Source2: 	qt.sh
Source3: 	qt.csh
Source4: 	designer3.desktop
Source5: 	assistant3.desktop
Source6: 	linguist3.desktop
Source7: 	qtconfig3.desktop
Patch2: 	qt-3.0.5-nodebug.patch
Patch3: 	qt-3.1.0-makefile.patch
Patch5: 	qt-x11-free-3.3.6-strip.patch
Patch7: 	qt-x11-free-3.3.2-quiet.patch
Patch8: 	qt-x11-free-3.3.3-qembed.patch
Patch12: 	qt-uic-nostdlib.patch
Patch13: 	qt-x11-free-3.3.6-qfontdatabase_x11.patch
Patch14:	qt-x11-free-3.3.3-gl.patch
Patch19: 	qt-3.3.3-gtkstyle.patch 
Patch24: 	qt-x11-free-3.3.5-uic.patch
Patch25: 	qt-x11-free-3.3.6-uic-multilib.patch
# immodule patches
Patch50: 	qt-x11-immodule-unified-qt3.3.8-20070321.patch
# qt-copy patches
Patch100: 	0038-dragobject-dont-prefer-unknown.patch
Patch101: 	0047-fix-kmenu-width.diff
Patch102: 	0048-qclipboard_hack_80072.patch
Patch103: 	0056-khotkeys_input_84434.patch
# upstream patches
Patch200: 	qt-x11-free-3.3.4-fullscreen.patch
Patch201: 	qt-x11-free-3.3.8b-gcc43.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
#BuildRequires:	xorg-devel libjpeg-devel libmng-devel libpng-devel libstdc++-devel glibc-devel zlib-devel libungif-devel perl sed cups-devel tar freetype-devel fontconfig-devel
#BuildRequires:	xorg-Mesa-devel
#Requires: 	fileutils
Requires: 	fontconfig >= 2.0
Requires: 	/etc/ld.so.conf.d

BuildRequires: 	desktop-file-utils
BuildRequires: 	libmng-devel
BuildRequires: 	glibc-devel
BuildRequires: 	libjpeg-devel
BuildRequires: 	libpng-devel
BuildRequires: 	zlib-devel
BuildRequires: 	perl
BuildRequires: 	sed
BuildRequires: 	findutils
BuildRequires: 	cups-devel
BuildRequires: 	tar
BuildRequires: 	freetype-devel
BuildRequires: 	fontconfig-devel
BuildRequires: 	libXrender-devel
BuildRequires: 	libXrandr-devel
BuildRequires: 	libXcursor-devel
BuildRequires: 	libXinerama-devel
BuildRequires: 	libXft-devel
BuildRequires: 	libXext-devel
BuildRequires: 	libX11-devel
BuildRequires: 	libSM-devel
BuildRequires: 	libICE-devel
BuildRequires: 	libXt-devel
BuildRequires: 	libXmu-devel
BuildRequires: 	xorg-x11-proto-devel
BuildRequires: 	mesa-libGL-devel
BuildRequires: 	mesa-libGLU-devel

Obsoletes: qt < %{version}-%{release}
Provides: qt = %{version}-%{release}

%define rpmcflags -Os -march=i686 -pipe -fomit-frame-pointer

%description
Qt is a widget library, forming the base of KDE and other X applications.

%package config
Summary: 	Grapical configuration tool for programs using Qt
Group: 		System/Libraries
Requires: 	%{name} = %{version}-%{release}
Obsoletes: qt-config < %{version}-%{release}
Provides: qt-config = %{version}-%{release}



%package devel
Summary: 	Development files and documentation for the Qt GUI toolkit.
Group: 		System/Libraries
Requires: 	%{name} = %{version}-%{release}
Requires: 	freetype-devel
Requires: 	fontconfig-devel
Requires: 	libXrender-devel
Requires: 	libXrandr-devel
Requires: 	libXcursor-devel
Requires: 	libXinerama-devel
Requires: 	libXft-devel
Requires: 	libXext-devel
Requires: 	libX11-devel
Requires: 	libSM-devel
Requires: 	libICE-devel
Requires: 	libXt-devel
Requires: 	xorg-x11-proto-devel
Requires: 	libpng-devel
Requires: 	libjpeg-devel
Requires: 	libmng-devel
Requires: 	pkg-config
Requires: 	mesa-libGL-devel
Requires: 	mesa-libGLU-devel
Obsoletes: qt-devel < %{version}-%{release}
Provides: qt-devel = %{version}-%{release}

%package styles
Summary: 	Extra styles for the Qt GUI toolkit.
Group: 		System/Libraries
Requires: 	%{name} = %{version}-%{release}

%package static
Summary: 	Version of the Qt GUI toolkit for static linking
Group: 		System/Libraries
Requires: 	%{name}-devel = %{version}-%{release}


%package designer
Summary: 	Interface designer (IDE) for the Qt toolkit
Group: 		System/Libraries
Requires: 	%{name}-devel = %{version}-%{release}
Obsoletes: qt-designer < %{version}-%{release}
Provides: qt-designer = %{version}-%{release}


%description
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications
for the X Window System.

Qt is written in C++ and is fully object-oriented.

This package contains the shared library needed to run qt
applications, as well as the README files for qt.


%description config
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications
for the X Window System.

Qt is written in C++ and is fully object-oriented.

This package contains a grapical configuration tool for programs using Qt.


%description devel
The qt-devel package contains the files necessary to develop
applications using the Qt GUI toolkit: the header files, the Qt meta
object compiler, the man pages, the HTML documentation and example
programs.

Install qt-devel if you want to develop GUI applications using the Qt
toolkit.

%description static
Version of the Qt library for static linking

%description styles
Extra styles (themes) for the Qt GUI toolkit.

%description designer
The qt-designer package contains an User Interface designer tool
for the Qt toolkit.

%prep
%setup -q -n qt-x11-free-%{version}

%patch2 -p1 -b .ndebug
%patch3 -p1 -b .makefile
#%patch5 -p1
%patch7 -p1 -b .quiet
%patch8 -p1 -b .qembed
%patch12 -p1 -b .nostdlib
%patch13 -p1 -b .fonts
%patch14 -p1 -b .gl
%patch19 -p1 -b .gtk
#%patch20 -p1 -b .gcc4-buildkey
%patch24 -p1 -b .uic
#%patch25 -p1 -b .uic-multilib

%if %{immodule}
%patch50 -p1 -b .immodule
pushd include/
ln -s ../src/kernel/qinputcontext.h qinputcontext.h
ln -s ../src/inputmethod/qinputcontextfactory.h qinputcontextfactory.h
ln -s ../src/inputmethod/qinputcontextplugin.h qinputcontextplugin.h
popd
#%patch51 -p1
#%patch52 -p1 -b .post
#%patch53 -p1 -b .quiet
#%patch54 -p1 -b .fix-key-release-event-with-imm
#%patch55 -p1 -b .resetinputcontext
%endif

%patch100 -p0 -b .0038-dragobject-dont-prefer-unknown
%patch101 -p1 -b .0047-fix-kmenu-width
%patch102 -p1 -b .0048-qclipboard_hack_80072
%patch103 -p0 -b .0056-khotkeys_input_84434
%patch200 -p1 -b .fullscreen
%patch201 -p1 -b .gcc43

%build
export QTDIR=`/bin/pwd`
export LD_LIBRARY_PATH="$QTDIR/lib:$LD_LIBRARY_PATH"
export PATH="$QTDIR/bin:$PATH"
export QTDEST=%{qtdir}

export SMP_MFLAGS="%{?_smp_mflags}"

%if %{immodule}
   sh ./make-symlinks.sh
%endif

# set correct X11 prefix
perl -pi -e "s,QMAKE_LIBDIR_X11.*,QMAKE_LIBDIR_X11\t=," mkspecs/*/qmake.conf
perl -pi -e "s,QMAKE_INCDIR_X11.*,QMAKE_INCDIR_X11\t=," mkspecs/*/qmake.conf
perl -pi -e "s,QMAKE_INCDIR_OPENGL.*,QMAKE_INCDIR_OPENGL\t=," mkspecs/*/qmake.conf
perl -pi -e "s,QMAKE_LIBDIR_OPENGL.*,QMAKE_LIBDIR_OPENGL\t=," mkspecs/*/qmake.conf

# don't use rpath
perl -pi -e "s|-Wl,-rpath,| |" mkspecs/*/qmake.conf

perl -pi -e "s|-O2|$INCLUDES %{optflags}|g" mkspecs/*/qmake.conf

# build shared, threaded (default) libraries
echo yes | ./configure \
  -prefix $QTDEST \
  -docdir %{qt_docdir} \
  -platform linux-g++ \
  -release \
  -shared \
  -largefile \
  -qt-gif \
  -system-zlib \
  -system-libpng \
  -system-libmng \
  -system-libjpeg \
  -no-exceptions \
  -enable-styles \
  -enable-tools \
  -enable-kernel \
  -enable-widgets \
  -enable-dialogs \
  -enable-iconview \
  -enable-workspace \
  -enable-network \
  -enable-canvas \
  -enable-table \
  -enable-xml \
  -enable-opengl \
  -enable-sql \
  -qt-style-motif \
  %{plugins} \
  -stl \
%if %{buildmt}
  -thread \
%endif
%if %{cups}
  -cups \
%endif
  -sm \
  -xinerama \
  -xrender \
  -xkb \
  -ipv6 \
  -dlopen-opengl \
  -xft

make $SMP_MFLAGS src-qmake

# build sqlite plugin
#pushd plugins/src/sqldrivers/sqlite
#qmake -o Makefile sqlite.pro
#popd

# build mysql plugin
#pushd plugins/src/sqldrivers/mysql
#qmake -o Makefile "INCLUDEPATH+=%{mysql_include_dir}" "LIBS+=-L%{mysql_lib_dir} -lmysqlclient" mysql.pro
#popd

make $SMP_MFLAGS src-moc
make $SMP_MFLAGS sub-src
make $SMP_MFLAGS sub-tools UIC="$QTDIR/bin/uic -nostdlib -L $QTDIR/plugins"

%install
rm -rf %{buildroot}

export QTDIR=`/bin/pwd`
export LD_LIBRARY_PATH="$QTDIR/lib:$LD_LIBRARY_PATH"
export PATH="$QTDIR/bin:$PATH"
export QTDEST=%{qtdir}

make install INSTALL_ROOT=%{buildroot}

for i in findtr qt20fix qtrename140 lrelease lupdate ; do
   install bin/$i %{buildroot}%{qtdir}/bin/
done

mkdir -p %{buildroot}%{_libdir}/pkgconfig/
mv %{buildroot}%{qtdir}/lib/pkgconfig/*.pc %{buildroot}%{_libdir}/pkgconfig/

# install man pages
mkdir -p %{buildroot}%{_mandir}
cp -fR doc/man/* %{buildroot}%{_mandir}/

# clean up
make -C tutorial clean
make -C examples clean

# Make sure the examples can be built outside the source tree.
# Our binaries fulfill all requirements, so...
perl -pi -e "s,^DEPENDPATH.*,,g;s,^REQUIRES.*,,g" `find examples -name "*.pro"`

# don't include Makefiles of qt examples/tutorials
find examples -name "Makefile" | xargs rm -f
find examples -name "*.obj" | xargs rm -rf
find examples -name "*.moc" | xargs rm -rf
find tutorial -name "Makefile" | xargs rm -f

for a in */*/Makefile ; do
  sed 's|^SYSCONF_MOC.*|SYSCONF_MOC		= %{qtdir}/bin/moc|' < $a > ${a}.2
  mv -v ${a}.2 $a
done

mkdir -p %{buildroot}/etc/profile.d
install -m 755 %{SOURCE2} %{SOURCE3} %{buildroot}/etc/profile.d/

# Add desktop files
mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install \
  --dir %{buildroot}%{_datadir}/applications \
  --vendor="qt" \
  %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7}

# Patch qmake to use qt-mt unconditionally
perl -pi -e "s,-lqt ,-lqt-mt ,g;s,-lqt$,-lqt-mt,g" %{buildroot}%{qtdir}/mkspecs/*/qmake.conf

# remove broken links
rm -f %{buildroot}%{qtdir}/mkspecs/default/linux-g++*
rm -f %{buildroot}%{qtdir}/lib/*.la

mkdir -p %{buildroot}/etc/ld.so.conf.d
echo "%{qtdir}/lib" > %{buildroot}/etc/ld.so.conf.d/qt-%{_arch}.conf

# install icons
mkdir %{buildroot}%{_datadir}/pixmaps
install -m 644 tools/assistant/images/qt.png %{buildroot}%{_datadir}/pixmaps/qtconfig3.png
install -m 644 tools/assistant/images/designer.png %{buildroot}%{_datadir}/pixmaps/designer3.png
install -m 644 tools/assistant/images/assistant.png %{buildroot}%{_datadir}/pixmaps/assistant3.png
install -m 644 tools/assistant/images/linguist.png %{buildroot}%{_datadir}/pixmaps/linguist3.png

# own style directory
mkdir -p %{buildroot}%{qtdir}/plugins/styles

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc FAQ LICENSE*
%dir %{qtdir}
%dir %{qtdir}/bin
%dir %{qtdir}/lib
%dir %{qtdir}/plugins
%dir %{qtdir}/plugins/styles
%if %{immodule}
%{qtdir}/plugins/inputmethods
%endif
%attr(0755,root,root) %config /etc/profile.d/*
/etc/ld.so.conf.d/*
%{qtdir}/lib/libqui.so.*
%{qtdir}/lib/libqt*.so.*
#%{qtdir}/plugins/sqldrivers/libqsqlite.so
#%{qtdir}/plugins/sqldrivers/libqsqlmysql.so


%files config
%defattr(-,root,root,-)
%{qtdir}/bin/qtconfig
%{_datadir}/applications/*qtconfig*.desktop
%{_datadir}/pixmaps/qtconfig3.png

%files devel
%defattr(-,root,root,-)
%{qtdir}/bin/moc
%{qtdir}/bin/uic
%{qtdir}/bin/findtr
%{qtdir}/bin/qt20fix
%{qtdir}/bin/qtrename140
%{qtdir}/bin/assistant
%{qtdir}/bin/qm2ts
%{qtdir}/bin/qmake
%{qtdir}/bin/qembed
%{qtdir}/bin/linguist
%{qtdir}/bin/lupdate
%{qtdir}/bin/lrelease
%{qtdir}/include
%{qtdir}/mkspecs
%{qtdir}/lib/libqt*.so
%{qtdir}/lib/libqui.so
%{qtdir}/lib/libeditor.a
%{qtdir}/lib/libdesigner*.a
%{qtdir}/lib/libqassistantclient.a
%{qtdir}/lib/*.prl
%{qtdir}/translations
%{qtdir}/phrasebooks
%{_libdir}/pkgconfig/*
%{_datadir}/applications/*linguist*.desktop
%{_datadir}/applications/*assistant*.desktop
%{_datadir}/pixmaps/linguist3.png
%{_datadir}/pixmaps/assistant3.png
%doc %{qt_docdir}/html
%doc examples
%doc tutorial
%{_mandir}/*/*

%files designer
%defattr(-,root,root,-)
%dir %{qtdir}/plugins/designer
%{qtdir}/templates
%{qtdir}/plugins/designer/*
%{qtdir}/bin/designer
%{_datadir}/applications/*designer*.desktop
%{_datadir}/pixmaps/designer3.png


%changelog
* Tue Aug 11 2009 Karsten Brockmann <arcam@ccux-linux.de> 3.3.8b-4
- rebuilt against libjpeg 7
* Thu Jul 31 2008 Christian Metzen <metzench@ccux-linux.de> 3.3.8b-3
- fixed desktop files
* Wed Jul 30 2008 Christian Metzen <metzench@ccux-linux.de> 3.3.8b-2
- added profile files
* Wed Jul 30 2008 Christian Metzen <metzench@ccux-linux.de> 3.3.8b-1
- Version update
- moved prefix
- rename package to qt3
* Tue May 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 3.3.8-2
- rebuilt against gcc 4.2
* Tue Apr 02 2007 Karsten Brockmann <arcam@ccux-linux.de> 3.3.8-1
- Version update
* Sun Jan 28 2007 Karsten Brockmann <arcam@ccux-linux.de> 3.3.7-2
- rebuilt against glibc 2.5 / gcc 4.1.1
* Sun Oct 22 2006 Karsten Brockmann <arcam@ccux-linux.de> 3.3.7-1
- Version update
* Sun Sep 10 2006 Christian Metzen <metzench@ccux-linux.de> 3.3.6-4
- modified requires for xorg 7.1
* Sun Apr 16 2006 Christian Metzen <metzench@ccux-linux.de> 3.3.6-3
- modified qtrc
* Sun Apr 16 2006 Christian Metzen <metzench@ccux-linux.de> 3.3.6-2
- Mofified packages, redefined requires, more options
* Sat Mar 25 2006 Karsten Brockmann <arcam@ccux-linux.de> 3.3.6-1
- Version update
* Sat Mar 11 2006 Karsten Brockmann <arcam@ccux-linux.de> 3.3.5-5
- Added UIC fix patch
* Sat Feb 11 2006 Stefan Gottwald <gotti@ccux-linux.de> 3.3.5-4
- Added install of findtr, msg2qm and mergetr for localisation support
* Wed Jan 11 2006 Christian Metzen <metzench@ccux-linux.de> 3.3.5-3
- Added immodule patches
* Sun Jan 08 2006 Christian Metzen <metzench@ccux-linux.de> 3.3.5-2
- Fixed Bug in update Package
* Fri Jan 06 2006 Karsten Brockmann <arcam@ccux-linux.de> 3.3.5-1
- Version Update
* Thu Mar 03 2005 Christian Metzen <metzench@ccux-linux.de> 3.3.4-3
- Temp. removed Immodules Patch
* Tue Mar 01 2005 Christian Metzen <metzench@ccux-linux.de> 3.3.4-2
- Added immodule Patch
* Sun Feb 19 2005 Christian Metzen <metzench@ccux-linux.de> 3.3.4-1
- Version Update to 3.3.4
* Wed Aug 23 2004 Christian Metzen <metzench@ccux-linux.de> 3.3.3-1
- Initial Release
